/* Auto-generated by genmsg_cpp for file /tmp/buildd/ros-cturtle-arm-navigation-0.2.4/debian/ros-cturtle-arm-navigation/opt/ros/cturtle/stacks/arm_navigation/move_arm_msgs/msg/MoveArmGoal.msg */
#ifndef MOVE_ARM_MSGS_MESSAGE_MOVEARMGOAL_H
#define MOVE_ARM_MSGS_MESSAGE_MOVEARMGOAL_H
#include <string>
#include <vector>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/message.h"
#include "ros/time.h"

#include "motion_planning_msgs/MotionPlanRequest.h"

namespace move_arm_msgs
{
template <class ContainerAllocator>
struct MoveArmGoal_ : public ros::Message
{
  typedef MoveArmGoal_<ContainerAllocator> Type;

  MoveArmGoal_()
  : planner_service_name()
  , motion_plan_request()
  , accept_partial_plans(false)
  , accept_invalid_goals(false)
  , disable_ik(false)
  , disable_collision_monitoring(false)
  {
  }

  MoveArmGoal_(const ContainerAllocator& _alloc)
  : planner_service_name(_alloc)
  , motion_plan_request(_alloc)
  , accept_partial_plans(false)
  , accept_invalid_goals(false)
  , disable_ik(false)
  , disable_collision_monitoring(false)
  {
  }

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _planner_service_name_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  planner_service_name;

  typedef  ::motion_planning_msgs::MotionPlanRequest_<ContainerAllocator>  _motion_plan_request_type;
   ::motion_planning_msgs::MotionPlanRequest_<ContainerAllocator>  motion_plan_request;

  typedef uint8_t _accept_partial_plans_type;
  uint8_t accept_partial_plans;

  typedef uint8_t _accept_invalid_goals_type;
  uint8_t accept_invalid_goals;

  typedef uint8_t _disable_ik_type;
  uint8_t disable_ik;

  typedef uint8_t _disable_collision_monitoring_type;
  uint8_t disable_collision_monitoring;


private:
  static const char* __s_getDataType_() { return "move_arm_msgs/MoveArmGoal"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getDataType() { return __s_getDataType_(); }

  ROSCPP_DEPRECATED const std::string __getDataType() const { return __s_getDataType_(); }

private:
  static const char* __s_getMD5Sum_() { return "287eb746393b246c20c4539dd915bd9b"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getMD5Sum() { return __s_getMD5Sum_(); }

  ROSCPP_DEPRECATED const std::string __getMD5Sum() const { return __s_getMD5Sum_(); }

private:
  static const char* __s_getMessageDefinition_() { return "# Service name to call for getting a motion plan\n\
# Move arm will call a service on this service name \n\
# using the MotionPlanRequest specified here\n\
string planner_service_name\n\
\n\
# A motion planning request\n\
motion_planning_msgs/MotionPlanRequest motion_plan_request\n\
\n\
# OPTIONAL flag\n\
# Setting this flag to true will allow move_arm to accept plans that do not go all the way to the goal\n\
bool accept_partial_plans\n\
\n\
# OPTIONAL flag\n\
# Setting this flag to true will allow move_arm to accept invalid goals\n\
# This is useful if you are using a planner like CHOMP along with a noisy rapidly changing collision map\n\
# and you would like to plan to a goal near an object.\n\
bool accept_invalid_goals\n\
\n\
# OPTIONAL flag\n\
# Setting this flag to true will disable the call to IK for a pose goal\n\
bool disable_ik\n\
\n\
# OPTIONAL flag\n\
# Setting this flag to true will disable collision monitoring during execution of a trajectory\n\
bool disable_collision_monitoring\n\
================================================================================\n\
MSG: motion_planning_msgs/MotionPlanRequest\n\
# This service contains the definition for a request to the motion\n\
# planner and the output it provides\n\
\n\
# Parameters for the workspace that the planner should work inside\n\
motion_planning_msgs/WorkspaceParameters workspace_parameters\n\
\n\
# Starting state updates. If certain joints should be considered\n\
# at positions other than the current ones, these positions should\n\
# be set here\n\
motion_planning_msgs/RobotState start_state\n\
\n\
# The goal state for the model to plan for. The goal is achieved\n\
# if all constraints are satisfied\n\
motion_planning_msgs/Constraints goal_constraints\n\
\n\
# No state at any point along the path in the produced motion plan will violate these constraints\n\
motion_planning_msgs/Constraints path_constraints\n\
\n\
# A specification for regions where contact is \n\
# allowed up to a certain depth\n\
# Any collision within this set of regions with a link \n\
# specified in the message will be allowed if\n\
# it is less than the penetration depth specified in the message\n\
AllowedContactSpecification[] allowed_contacts\n\
\n\
# A set of ordered collision operations, \n\
# these are applied to all links, objects, \n\
# namespaces in the collision space\n\
OrderedCollisionOperations ordered_collision_operations\n\
\n\
# Specifies a set of links and paddings to change from the default\n\
# specified in the yaml file\n\
motion_planning_msgs/LinkPadding[] link_padding\n\
\n\
# The name of the motion planner to use. If no name is specified,\n\
# a default motion planner will be used\n\
string planner_id\n\
\n\
# The name of the group of joints on which this planner is operating\n\
string group_name\n\
\n\
# The number of times this plan is to be computed. Shortest solution\n\
# will be reported.\n\
int32 num_planning_attempts\n\
\n\
# The maximum amount of time the motion planner is allowed to plan for\n\
duration allowed_planning_time\n\
\n\
# An expected path duration (in seconds) along with an expected discretization of the path allows the planner to determine the discretization of the trajectory that it returns\n\
duration expected_path_duration\n\
duration expected_path_dt\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/WorkspaceParameters\n\
# This message contains a set of parameters useful in\n\
# setting up the workspace for planning\n\
geometric_shapes_msgs/Shape  workspace_region_shape\n\
geometry_msgs/PoseStamped    workspace_region_pose\n\
\n\
\n\
================================================================================\n\
MSG: geometric_shapes_msgs/Shape\n\
byte SPHERE=0\n\
byte BOX=1\n\
byte CYLINDER=2\n\
byte MESH=3\n\
\n\
byte type\n\
\n\
\n\
#### define sphere, box, cylinder ####\n\
# the origin of each shape is considered at the shape's center\n\
\n\
# for sphere\n\
# radius := dimensions[0]\n\
\n\
# for cylinder\n\
# radius := dimensions[0]\n\
# length := dimensions[1]\n\
# the length is along the Z axis\n\
\n\
# for box\n\
# size_x := dimensions[0]\n\
# size_y := dimensions[1]\n\
# size_z := dimensions[2]\n\
float64[] dimensions\n\
\n\
\n\
#### define mesh ####\n\
\n\
# list of triangles; triangle k is defined by tre vertices located\n\
# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n\
int32[] triangles\n\
geometry_msgs/Point[] vertices\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: roslib/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/RobotState\n\
# This message contains information about the robot state, i.e. the positions of its joints and links\n\
sensor_msgs/JointState joint_state\n\
motion_planning_msgs/MultiDOFJointState multi_dof_joint_state\n\
================================================================================\n\
MSG: sensor_msgs/JointState\n\
# This is a message that holds data to describe the state of a set of torque controlled joints. \n\
#\n\
# The state of each joint (revolute or prismatic) is defined by:\n\
#  * the position of the joint (rad or m),\n\
#  * the velocity of the joint (rad/s or m/s) and \n\
#  * the effort that is applied in the joint (Nm or N).\n\
#\n\
# Each joint is uniquely identified by its name\n\
# The header specifies the time at which the joint states were recorded. All the joint states\n\
# in one message have to be recorded at the same time.\n\
#\n\
# This message consists of a multiple arrays, one for each part of the joint state. \n\
# The goal is to make each of the fields optional. When e.g. your joints have no\n\
# effort associated with them, you can leave the effort array empty. \n\
#\n\
# All arrays in this message should have the same size, or be empty.\n\
# This is the only way to uniquely associate the joint name with the correct\n\
# states.\n\
\n\
\n\
Header header\n\
\n\
string[] name\n\
float64[] position\n\
float64[] velocity\n\
float64[] effort\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/MultiDOFJointState\n\
#A representation of a multi-dof joint state\n\
time stamp\n\
string joint_name\n\
string frame_id\n\
string child_frame_id\n\
geometry_msgs/Pose pose\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/Constraints\n\
# This message contains a list of motion planning constraints.\n\
\n\
motion_planning_msgs/JointConstraint[] joint_constraints\n\
motion_planning_msgs/PositionConstraint[] position_constraints\n\
motion_planning_msgs/OrientationConstraint[] orientation_constraints\n\
motion_planning_msgs/VisibilityConstraint[] visibility_constraints\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/JointConstraint\n\
# Constrain the position of a joint to be within a certain bound\n\
string joint_name\n\
\n\
# the bound to be achieved is [position - tolerance_below, position + tolerance_above]\n\
float64 position\n\
float64 tolerance_above\n\
float64 tolerance_below\n\
\n\
# A weighting factor for this constraint\n\
float64 weight\n\
================================================================================\n\
MSG: motion_planning_msgs/PositionConstraint\n\
# This message contains the definition of a position constraint.\n\
Header header\n\
\n\
# The robot link this constraint refers to\n\
string link_name\n\
\n\
# The offset (in the link frame) for the target point on the link we are planning for\n\
geometry_msgs/Point target_point_offset\n\
\n\
# The nominal/target position for the point we are planning for\n\
geometry_msgs/Point position\n\
\n\
# The shape of the bounded region that constrains the position of the end-effector\n\
# This region is always centered at the position defined above\n\
geometric_shapes_msgs/Shape constraint_region_shape\n\
\n\
# The orientation of the bounded region that constrains the position of the end-effector. \n\
# This allows the specification of non-axis aligned constraints\n\
geometry_msgs/Quaternion constraint_region_orientation\n\
\n\
# Constraint weighting factor - a weight for this constraint\n\
float64 weight\n\
================================================================================\n\
MSG: motion_planning_msgs/OrientationConstraint\n\
# This message contains the definition of an orientation constraint.\n\
Header header\n\
\n\
# The robot link this constraint refers to\n\
string link_name\n\
\n\
# The type of the constraint\n\
int32 type\n\
int32 LINK_FRAME=0\n\
int32 HEADER_FRAME=1\n\
\n\
# The desired orientation of the robot link specified as a quaternion\n\
geometry_msgs/Quaternion orientation\n\
\n\
# optional RPY error tolerances specified if \n\
float64 absolute_roll_tolerance\n\
float64 absolute_pitch_tolerance\n\
float64 absolute_yaw_tolerance\n\
\n\
# Constraint weighting factor - a weight for this constraint\n\
float64 weight\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/VisibilityConstraint\n\
# This message contains the definition of a visibility constraint.\n\
Header header\n\
\n\
# The point stamped target that needs to be kept within view of the sensor\n\
geometry_msgs/PointStamped target\n\
\n\
# The local pose of the frame in which visibility is to be maintained\n\
# The frame id should represent the robot link to which the sensor is attached\n\
# The visual axis of the sensor is assumed to be along the X axis of this frame\n\
geometry_msgs/PoseStamped sensor_pose\n\
\n\
# The deviation (in radians) that will be tolerated\n\
# Constraint error will be measured as the solid angle between the \n\
# X axis of the frame defined above and the vector between the origin \n\
# of the frame defined above and the target location\n\
float64 absolute_tolerance\n\
\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PointStamped\n\
# This represents a Point with reference coordinate frame and timestamp\n\
Header header\n\
Point point\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/AllowedContactSpecification\n\
# The names of the regions\n\
string name\n\
\n\
# The shape of the region in the environment\n\
geometric_shapes_msgs/Shape shape\n\
\n\
# The pose of the space defining the region\n\
geometry_msgs/PoseStamped pose_stamped\n\
\n\
# The set of links that will be allowed to have penetration contact within this region\n\
string[] link_names\n\
\n\
# The maximum penetration depth allowed for every link\n\
float64 penetration_depth\n\
================================================================================\n\
MSG: motion_planning_msgs/OrderedCollisionOperations\n\
# A set of collision operations that will be performed in the order they are specified\n\
CollisionOperation[] collision_operations\n\
================================================================================\n\
MSG: motion_planning_msgs/CollisionOperation\n\
# A definition of a collision operation\n\
# E.g. (\"gripper\",COLLISION_SET_ALL,ENABLE) will enable collisions \n\
# between the gripper and all objects in the collision space\n\
\n\
string object1\n\
string object2\n\
string COLLISION_SET_ALL=\"all\"\n\
string COLLISION_SET_OBJECTS=\"objects\"\n\
string COLLISION_SET_ATTACHED_OBJECTS=\"attached\"\n\
\n\
# The penetration distance to which collisions are allowed. This is 0.0 by default.\n\
float64 penetration_distance\n\
\n\
# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above\n\
int32 operation\n\
int32 DISABLE=0\n\
int32 ENABLE=1\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/LinkPadding\n\
#name for the link\n\
string link_name\n\
\n\
# padding to apply to the link\n\
float64 padding\n\
\n\
"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getMessageDefinition() { return __s_getMessageDefinition_(); }

  ROSCPP_DEPRECATED const std::string __getMessageDefinition() const { return __s_getMessageDefinition_(); }

  ROSCPP_DEPRECATED virtual uint8_t *serialize(uint8_t *write_ptr, uint32_t seq) const
  {
    ros::serialization::OStream stream(write_ptr, 1000000000);
    ros::serialization::serialize(stream, planner_service_name);
    ros::serialization::serialize(stream, motion_plan_request);
    ros::serialization::serialize(stream, accept_partial_plans);
    ros::serialization::serialize(stream, accept_invalid_goals);
    ros::serialization::serialize(stream, disable_ik);
    ros::serialization::serialize(stream, disable_collision_monitoring);
    return stream.getData();
  }

  ROSCPP_DEPRECATED virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    ros::serialization::IStream stream(read_ptr, 1000000000);
    ros::serialization::deserialize(stream, planner_service_name);
    ros::serialization::deserialize(stream, motion_plan_request);
    ros::serialization::deserialize(stream, accept_partial_plans);
    ros::serialization::deserialize(stream, accept_invalid_goals);
    ros::serialization::deserialize(stream, disable_ik);
    ros::serialization::deserialize(stream, disable_collision_monitoring);
    return stream.getData();
  }

  ROSCPP_DEPRECATED virtual uint32_t serializationLength() const
  {
    uint32_t size = 0;
    size += ros::serialization::serializationLength(planner_service_name);
    size += ros::serialization::serializationLength(motion_plan_request);
    size += ros::serialization::serializationLength(accept_partial_plans);
    size += ros::serialization::serializationLength(accept_invalid_goals);
    size += ros::serialization::serializationLength(disable_ik);
    size += ros::serialization::serializationLength(disable_collision_monitoring);
    return size;
  }

  typedef boost::shared_ptr< ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::move_arm_msgs::MoveArmGoal_<ContainerAllocator>  const> ConstPtr;
}; // struct MoveArmGoal
typedef  ::move_arm_msgs::MoveArmGoal_<std::allocator<void> > MoveArmGoal;

typedef boost::shared_ptr< ::move_arm_msgs::MoveArmGoal> MoveArmGoalPtr;
typedef boost::shared_ptr< ::move_arm_msgs::MoveArmGoal const> MoveArmGoalConstPtr;


template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const  ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> & v)
{
  ros::message_operations::Printer< ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> >::stream(s, "", v);
  return s;}

} // namespace move_arm_msgs

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator>
struct MD5Sum< ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> > {
  static const char* value() 
  {
    return "287eb746393b246c20c4539dd915bd9b";
  }

  static const char* value(const  ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0x287eb746393b246cULL;
  static const uint64_t static_value2 = 0x20c4539dd915bd9bULL;
};

template<class ContainerAllocator>
struct DataType< ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> > {
  static const char* value() 
  {
    return "move_arm_msgs/MoveArmGoal";
  }

  static const char* value(const  ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> > {
  static const char* value() 
  {
    return "# Service name to call for getting a motion plan\n\
# Move arm will call a service on this service name \n\
# using the MotionPlanRequest specified here\n\
string planner_service_name\n\
\n\
# A motion planning request\n\
motion_planning_msgs/MotionPlanRequest motion_plan_request\n\
\n\
# OPTIONAL flag\n\
# Setting this flag to true will allow move_arm to accept plans that do not go all the way to the goal\n\
bool accept_partial_plans\n\
\n\
# OPTIONAL flag\n\
# Setting this flag to true will allow move_arm to accept invalid goals\n\
# This is useful if you are using a planner like CHOMP along with a noisy rapidly changing collision map\n\
# and you would like to plan to a goal near an object.\n\
bool accept_invalid_goals\n\
\n\
# OPTIONAL flag\n\
# Setting this flag to true will disable the call to IK for a pose goal\n\
bool disable_ik\n\
\n\
# OPTIONAL flag\n\
# Setting this flag to true will disable collision monitoring during execution of a trajectory\n\
bool disable_collision_monitoring\n\
================================================================================\n\
MSG: motion_planning_msgs/MotionPlanRequest\n\
# This service contains the definition for a request to the motion\n\
# planner and the output it provides\n\
\n\
# Parameters for the workspace that the planner should work inside\n\
motion_planning_msgs/WorkspaceParameters workspace_parameters\n\
\n\
# Starting state updates. If certain joints should be considered\n\
# at positions other than the current ones, these positions should\n\
# be set here\n\
motion_planning_msgs/RobotState start_state\n\
\n\
# The goal state for the model to plan for. The goal is achieved\n\
# if all constraints are satisfied\n\
motion_planning_msgs/Constraints goal_constraints\n\
\n\
# No state at any point along the path in the produced motion plan will violate these constraints\n\
motion_planning_msgs/Constraints path_constraints\n\
\n\
# A specification for regions where contact is \n\
# allowed up to a certain depth\n\
# Any collision within this set of regions with a link \n\
# specified in the message will be allowed if\n\
# it is less than the penetration depth specified in the message\n\
AllowedContactSpecification[] allowed_contacts\n\
\n\
# A set of ordered collision operations, \n\
# these are applied to all links, objects, \n\
# namespaces in the collision space\n\
OrderedCollisionOperations ordered_collision_operations\n\
\n\
# Specifies a set of links and paddings to change from the default\n\
# specified in the yaml file\n\
motion_planning_msgs/LinkPadding[] link_padding\n\
\n\
# The name of the motion planner to use. If no name is specified,\n\
# a default motion planner will be used\n\
string planner_id\n\
\n\
# The name of the group of joints on which this planner is operating\n\
string group_name\n\
\n\
# The number of times this plan is to be computed. Shortest solution\n\
# will be reported.\n\
int32 num_planning_attempts\n\
\n\
# The maximum amount of time the motion planner is allowed to plan for\n\
duration allowed_planning_time\n\
\n\
# An expected path duration (in seconds) along with an expected discretization of the path allows the planner to determine the discretization of the trajectory that it returns\n\
duration expected_path_duration\n\
duration expected_path_dt\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/WorkspaceParameters\n\
# This message contains a set of parameters useful in\n\
# setting up the workspace for planning\n\
geometric_shapes_msgs/Shape  workspace_region_shape\n\
geometry_msgs/PoseStamped    workspace_region_pose\n\
\n\
\n\
================================================================================\n\
MSG: geometric_shapes_msgs/Shape\n\
byte SPHERE=0\n\
byte BOX=1\n\
byte CYLINDER=2\n\
byte MESH=3\n\
\n\
byte type\n\
\n\
\n\
#### define sphere, box, cylinder ####\n\
# the origin of each shape is considered at the shape's center\n\
\n\
# for sphere\n\
# radius := dimensions[0]\n\
\n\
# for cylinder\n\
# radius := dimensions[0]\n\
# length := dimensions[1]\n\
# the length is along the Z axis\n\
\n\
# for box\n\
# size_x := dimensions[0]\n\
# size_y := dimensions[1]\n\
# size_z := dimensions[2]\n\
float64[] dimensions\n\
\n\
\n\
#### define mesh ####\n\
\n\
# list of triangles; triangle k is defined by tre vertices located\n\
# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n\
int32[] triangles\n\
geometry_msgs/Point[] vertices\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: roslib/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/RobotState\n\
# This message contains information about the robot state, i.e. the positions of its joints and links\n\
sensor_msgs/JointState joint_state\n\
motion_planning_msgs/MultiDOFJointState multi_dof_joint_state\n\
================================================================================\n\
MSG: sensor_msgs/JointState\n\
# This is a message that holds data to describe the state of a set of torque controlled joints. \n\
#\n\
# The state of each joint (revolute or prismatic) is defined by:\n\
#  * the position of the joint (rad or m),\n\
#  * the velocity of the joint (rad/s or m/s) and \n\
#  * the effort that is applied in the joint (Nm or N).\n\
#\n\
# Each joint is uniquely identified by its name\n\
# The header specifies the time at which the joint states were recorded. All the joint states\n\
# in one message have to be recorded at the same time.\n\
#\n\
# This message consists of a multiple arrays, one for each part of the joint state. \n\
# The goal is to make each of the fields optional. When e.g. your joints have no\n\
# effort associated with them, you can leave the effort array empty. \n\
#\n\
# All arrays in this message should have the same size, or be empty.\n\
# This is the only way to uniquely associate the joint name with the correct\n\
# states.\n\
\n\
\n\
Header header\n\
\n\
string[] name\n\
float64[] position\n\
float64[] velocity\n\
float64[] effort\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/MultiDOFJointState\n\
#A representation of a multi-dof joint state\n\
time stamp\n\
string joint_name\n\
string frame_id\n\
string child_frame_id\n\
geometry_msgs/Pose pose\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/Constraints\n\
# This message contains a list of motion planning constraints.\n\
\n\
motion_planning_msgs/JointConstraint[] joint_constraints\n\
motion_planning_msgs/PositionConstraint[] position_constraints\n\
motion_planning_msgs/OrientationConstraint[] orientation_constraints\n\
motion_planning_msgs/VisibilityConstraint[] visibility_constraints\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/JointConstraint\n\
# Constrain the position of a joint to be within a certain bound\n\
string joint_name\n\
\n\
# the bound to be achieved is [position - tolerance_below, position + tolerance_above]\n\
float64 position\n\
float64 tolerance_above\n\
float64 tolerance_below\n\
\n\
# A weighting factor for this constraint\n\
float64 weight\n\
================================================================================\n\
MSG: motion_planning_msgs/PositionConstraint\n\
# This message contains the definition of a position constraint.\n\
Header header\n\
\n\
# The robot link this constraint refers to\n\
string link_name\n\
\n\
# The offset (in the link frame) for the target point on the link we are planning for\n\
geometry_msgs/Point target_point_offset\n\
\n\
# The nominal/target position for the point we are planning for\n\
geometry_msgs/Point position\n\
\n\
# The shape of the bounded region that constrains the position of the end-effector\n\
# This region is always centered at the position defined above\n\
geometric_shapes_msgs/Shape constraint_region_shape\n\
\n\
# The orientation of the bounded region that constrains the position of the end-effector. \n\
# This allows the specification of non-axis aligned constraints\n\
geometry_msgs/Quaternion constraint_region_orientation\n\
\n\
# Constraint weighting factor - a weight for this constraint\n\
float64 weight\n\
================================================================================\n\
MSG: motion_planning_msgs/OrientationConstraint\n\
# This message contains the definition of an orientation constraint.\n\
Header header\n\
\n\
# The robot link this constraint refers to\n\
string link_name\n\
\n\
# The type of the constraint\n\
int32 type\n\
int32 LINK_FRAME=0\n\
int32 HEADER_FRAME=1\n\
\n\
# The desired orientation of the robot link specified as a quaternion\n\
geometry_msgs/Quaternion orientation\n\
\n\
# optional RPY error tolerances specified if \n\
float64 absolute_roll_tolerance\n\
float64 absolute_pitch_tolerance\n\
float64 absolute_yaw_tolerance\n\
\n\
# Constraint weighting factor - a weight for this constraint\n\
float64 weight\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/VisibilityConstraint\n\
# This message contains the definition of a visibility constraint.\n\
Header header\n\
\n\
# The point stamped target that needs to be kept within view of the sensor\n\
geometry_msgs/PointStamped target\n\
\n\
# The local pose of the frame in which visibility is to be maintained\n\
# The frame id should represent the robot link to which the sensor is attached\n\
# The visual axis of the sensor is assumed to be along the X axis of this frame\n\
geometry_msgs/PoseStamped sensor_pose\n\
\n\
# The deviation (in radians) that will be tolerated\n\
# Constraint error will be measured as the solid angle between the \n\
# X axis of the frame defined above and the vector between the origin \n\
# of the frame defined above and the target location\n\
float64 absolute_tolerance\n\
\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PointStamped\n\
# This represents a Point with reference coordinate frame and timestamp\n\
Header header\n\
Point point\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/AllowedContactSpecification\n\
# The names of the regions\n\
string name\n\
\n\
# The shape of the region in the environment\n\
geometric_shapes_msgs/Shape shape\n\
\n\
# The pose of the space defining the region\n\
geometry_msgs/PoseStamped pose_stamped\n\
\n\
# The set of links that will be allowed to have penetration contact within this region\n\
string[] link_names\n\
\n\
# The maximum penetration depth allowed for every link\n\
float64 penetration_depth\n\
================================================================================\n\
MSG: motion_planning_msgs/OrderedCollisionOperations\n\
# A set of collision operations that will be performed in the order they are specified\n\
CollisionOperation[] collision_operations\n\
================================================================================\n\
MSG: motion_planning_msgs/CollisionOperation\n\
# A definition of a collision operation\n\
# E.g. (\"gripper\",COLLISION_SET_ALL,ENABLE) will enable collisions \n\
# between the gripper and all objects in the collision space\n\
\n\
string object1\n\
string object2\n\
string COLLISION_SET_ALL=\"all\"\n\
string COLLISION_SET_OBJECTS=\"objects\"\n\
string COLLISION_SET_ATTACHED_OBJECTS=\"attached\"\n\
\n\
# The penetration distance to which collisions are allowed. This is 0.0 by default.\n\
float64 penetration_distance\n\
\n\
# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above\n\
int32 operation\n\
int32 DISABLE=0\n\
int32 ENABLE=1\n\
\n\
================================================================================\n\
MSG: motion_planning_msgs/LinkPadding\n\
#name for the link\n\
string link_name\n\
\n\
# padding to apply to the link\n\
float64 padding\n\
\n\
";
  }

  static const char* value(const  ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.planner_service_name);
    stream.next(m.motion_plan_request);
    stream.next(m.accept_partial_plans);
    stream.next(m.accept_invalid_goals);
    stream.next(m.disable_ik);
    stream.next(m.disable_collision_monitoring);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct MoveArmGoal_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const  ::move_arm_msgs::MoveArmGoal_<ContainerAllocator> & v) 
  {
    s << indent << "planner_service_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.planner_service_name);
    s << indent << "motion_plan_request: ";
s << std::endl;
    Printer< ::motion_planning_msgs::MotionPlanRequest_<ContainerAllocator> >::stream(s, indent + "  ", v.motion_plan_request);
    s << indent << "accept_partial_plans: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.accept_partial_plans);
    s << indent << "accept_invalid_goals: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.accept_invalid_goals);
    s << indent << "disable_ik: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.disable_ik);
    s << indent << "disable_collision_monitoring: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.disable_collision_monitoring);
  }
};


} // namespace message_operations
} // namespace ros

#endif // MOVE_ARM_MSGS_MESSAGE_MOVEARMGOAL_H

