"""autogenerated by genmsg_py from MoveArmAction.msg. Do not edit."""
import roslib.message
import struct

import roslib.rostime
import actionlib_msgs.msg
import motion_planning_msgs.msg
import geometric_shapes_msgs.msg
import planning_environment_msgs.msg
import geometry_msgs.msg
import sensor_msgs.msg
import roslib.msg
import move_arm_msgs.msg

class MoveArmAction(roslib.message.Message):
  _md5sum = "417bfacf14aa74ebbb743329cf76b591"
  _type = "move_arm_msgs/MoveArmAction"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
MoveArmActionGoal action_goal
MoveArmActionResult action_result
MoveArmActionFeedback action_feedback

================================================================================
MSG: move_arm_msgs/MoveArmActionGoal

Header header
actionlib_msgs/GoalID goal_id
MoveArmGoal goal

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: move_arm_msgs/MoveArmGoal
# Service name to call for getting a motion plan
# Move arm will call a service on this service name 
# using the MotionPlanRequest specified here
string planner_service_name

# A motion planning request
motion_planning_msgs/MotionPlanRequest motion_plan_request

# OPTIONAL flag
# Setting this flag to true will allow move_arm to accept plans that do not go all the way to the goal
bool accept_partial_plans

# OPTIONAL flag
# Setting this flag to true will allow move_arm to accept invalid goals
# This is useful if you are using a planner like CHOMP along with a noisy rapidly changing collision map
# and you would like to plan to a goal near an object.
bool accept_invalid_goals

# OPTIONAL flag
# Setting this flag to true will disable the call to IK for a pose goal
bool disable_ik

# OPTIONAL flag
# Setting this flag to true will disable collision monitoring during execution of a trajectory
bool disable_collision_monitoring
================================================================================
MSG: motion_planning_msgs/MotionPlanRequest
# This service contains the definition for a request to the motion
# planner and the output it provides

# Parameters for the workspace that the planner should work inside
motion_planning_msgs/WorkspaceParameters workspace_parameters

# Starting state updates. If certain joints should be considered
# at positions other than the current ones, these positions should
# be set here
motion_planning_msgs/RobotState start_state

# The goal state for the model to plan for. The goal is achieved
# if all constraints are satisfied
motion_planning_msgs/Constraints goal_constraints

# No state at any point along the path in the produced motion plan will violate these constraints
motion_planning_msgs/Constraints path_constraints

# A specification for regions where contact is 
# allowed up to a certain depth
# Any collision within this set of regions with a link 
# specified in the message will be allowed if
# it is less than the penetration depth specified in the message
AllowedContactSpecification[] allowed_contacts

# A set of ordered collision operations, 
# these are applied to all links, objects, 
# namespaces in the collision space
OrderedCollisionOperations ordered_collision_operations

# Specifies a set of links and paddings to change from the default
# specified in the yaml file
motion_planning_msgs/LinkPadding[] link_padding

# The name of the motion planner to use. If no name is specified,
# a default motion planner will be used
string planner_id

# The name of the group of joints on which this planner is operating
string group_name

# The number of times this plan is to be computed. Shortest solution
# will be reported.
int32 num_planning_attempts

# The maximum amount of time the motion planner is allowed to plan for
duration allowed_planning_time

# An expected path duration (in seconds) along with an expected discretization of the path allows the planner to determine the discretization of the trajectory that it returns
duration expected_path_duration
duration expected_path_dt

================================================================================
MSG: motion_planning_msgs/WorkspaceParameters
# This message contains a set of parameters useful in
# setting up the workspace for planning
geometric_shapes_msgs/Shape  workspace_region_shape
geometry_msgs/PoseStamped    workspace_region_pose


================================================================================
MSG: geometric_shapes_msgs/Shape
byte SPHERE=0
byte BOX=1
byte CYLINDER=2
byte MESH=3

byte type


#### define sphere, box, cylinder ####
# the origin of each shape is considered at the shape's center

# for sphere
# radius := dimensions[0]

# for cylinder
# radius := dimensions[0]
# length := dimensions[1]
# the length is along the Z axis

# for box
# size_x := dimensions[0]
# size_y := dimensions[1]
# size_z := dimensions[2]
float64[] dimensions


#### define mesh ####

# list of triangles; triangle k is defined by tre vertices located
# at indices triangles[3k], triangles[3k+1], triangles[3k+2]
int32[] triangles
geometry_msgs/Point[] vertices

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: motion_planning_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state
motion_planning_msgs/MultiDOFJointState multi_dof_joint_state
================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: motion_planning_msgs/MultiDOFJointState
#A representation of a multi-dof joint state
time stamp
string joint_name
string frame_id
string child_frame_id
geometry_msgs/Pose pose

================================================================================
MSG: motion_planning_msgs/Constraints
# This message contains a list of motion planning constraints.

motion_planning_msgs/JointConstraint[] joint_constraints
motion_planning_msgs/PositionConstraint[] position_constraints
motion_planning_msgs/OrientationConstraint[] orientation_constraints
motion_planning_msgs/VisibilityConstraint[] visibility_constraints

================================================================================
MSG: motion_planning_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint
float64 weight
================================================================================
MSG: motion_planning_msgs/PositionConstraint
# This message contains the definition of a position constraint.
Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Point target_point_offset

# The nominal/target position for the point we are planning for
geometry_msgs/Point position

# The shape of the bounded region that constrains the position of the end-effector
# This region is always centered at the position defined above
geometric_shapes_msgs/Shape constraint_region_shape

# The orientation of the bounded region that constrains the position of the end-effector. 
# This allows the specification of non-axis aligned constraints
geometry_msgs/Quaternion constraint_region_orientation

# Constraint weighting factor - a weight for this constraint
float64 weight
================================================================================
MSG: motion_planning_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.
Header header

# The robot link this constraint refers to
string link_name

# The type of the constraint
int32 type
int32 LINK_FRAME=0
int32 HEADER_FRAME=1

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# optional RPY error tolerances specified if 
float64 absolute_roll_tolerance
float64 absolute_pitch_tolerance
float64 absolute_yaw_tolerance

# Constraint weighting factor - a weight for this constraint
float64 weight

================================================================================
MSG: motion_planning_msgs/VisibilityConstraint
# This message contains the definition of a visibility constraint.
Header header

# The point stamped target that needs to be kept within view of the sensor
geometry_msgs/PointStamped target

# The local pose of the frame in which visibility is to be maintained
# The frame id should represent the robot link to which the sensor is attached
# The visual axis of the sensor is assumed to be along the X axis of this frame
geometry_msgs/PoseStamped sensor_pose

# The deviation (in radians) that will be tolerated
# Constraint error will be measured as the solid angle between the 
# X axis of the frame defined above and the vector between the origin 
# of the frame defined above and the target location
float64 absolute_tolerance


================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: motion_planning_msgs/AllowedContactSpecification
# The names of the regions
string name

# The shape of the region in the environment
geometric_shapes_msgs/Shape shape

# The pose of the space defining the region
geometry_msgs/PoseStamped pose_stamped

# The set of links that will be allowed to have penetration contact within this region
string[] link_names

# The maximum penetration depth allowed for every link
float64 penetration_depth
================================================================================
MSG: motion_planning_msgs/OrderedCollisionOperations
# A set of collision operations that will be performed in the order they are specified
CollisionOperation[] collision_operations
================================================================================
MSG: motion_planning_msgs/CollisionOperation
# A definition of a collision operation
# E.g. ("gripper",COLLISION_SET_ALL,ENABLE) will enable collisions 
# between the gripper and all objects in the collision space

string object1
string object2
string COLLISION_SET_ALL="all"
string COLLISION_SET_OBJECTS="objects"
string COLLISION_SET_ATTACHED_OBJECTS="attached"

# The penetration distance to which collisions are allowed. This is 0.0 by default.
float64 penetration_distance

# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above
int32 operation
int32 DISABLE=0
int32 ENABLE=1

================================================================================
MSG: motion_planning_msgs/LinkPadding
#name for the link
string link_name

# padding to apply to the link
float64 padding

================================================================================
MSG: move_arm_msgs/MoveArmActionResult

Header header
actionlib_msgs/GoalStatus status
MoveArmResult result

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: move_arm_msgs/MoveArmResult
# An error code reflecting what went wrong
motion_planning_msgs/ArmNavigationErrorCodes error_code

planning_environment_msgs/ContactInformation[] contacts
================================================================================
MSG: motion_planning_msgs/ArmNavigationErrorCodes
int32 val

# overall behavior
int32 PLANNING_FAILED=-1
int32 SUCCESS=1
int32 TIMED_OUT=-2

# start state errors
int32 START_STATE_IN_COLLISION=-3
int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-4

# goal errors
int32 GOAL_IN_COLLISION=-5
int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-6

# robot state
int32 INVALID_ROBOT_STATE=-7
int32 INCOMPLETE_ROBOT_STATE=-8

# planning request errors
int32 INVALID_PLANNER_ID=-9
int32 INVALID_NUM_PLANNING_ATTEMPTS=-10
int32 INVALID_ALLOWED_PLANNING_TIME=-11
int32 INVALID_GROUP_NAME=-12
int32 INVALID_GOAL_JOINT_CONSTRAINTS=-13
int32 INVALID_GOAL_POSITION_CONSTRAINTS=-14
int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-15
int32 INVALID_PATH_JOINT_CONSTRAINTS=-16
int32 INVALID_PATH_POSITION_CONSTRAINTS=-17
int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-18

# state/trajectory monitor errors
int32 INVALID_TRAJECTORY=-19
int32 INVALID_INDEX=-20
int32 JOINT_LIMITS_VIOLATED=-21
int32 PATH_CONSTRAINTS_VIOLATED=-22
int32 COLLISION_CONSTRAINTS_VIOLATED=-23
int32 GOAL_CONSTRAINTS_VIOLATED=-24
int32 JOINTS_NOT_MOVING=-25
int32 TRAJECTORY_CONTROLLER_FAILED=-26

# system errors
int32 FRAME_TRANSFORM_FAILURE=-27
int32 COLLISION_CHECKING_UNAVAILABLE=-28
int32 ROBOT_STATE_STALE=-29
int32 SENSOR_INFO_STALE=-30

# kinematics errors
int32 NO_IK_SOLUTION=-31
int32 INVALID_LINK_NAME=-32
int32 IK_LINK_IN_COLLISION=-33
int32 NO_FK_SOLUTION=-34
int32 KINEMATICS_STATE_IN_COLLISION=-35

# general errors
int32 INVALID_TIMEOUT=-36


================================================================================
MSG: planning_environment_msgs/ContactInformation
# Standard ROS header contains information 
# about the frame in which this 
# contact is specified
Header header

# Position of the contact point
geometry_msgs/Point position

# Normal corresponding to the contact point
geometry_msgs/Vector3 normal 

# Depth of contact point
float64 depth

# Name of the first body that is in contact
# This could be a link or a namespace that represents a body
string contact_body_1
string attached_body_1
uint32 body_type_1

# Name of the second body that is in contact
# This could be a link or a namespace that represents a body
string contact_body_2
string attached_body_2
uint32 body_type_2

uint32 ROBOT_LINK=0
uint32 OBJECT=1
uint32 ATTACHED_BODY=2
================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: move_arm_msgs/MoveArmActionFeedback

Header header
actionlib_msgs/GoalStatus status
MoveArmFeedback feedback

================================================================================
MSG: move_arm_msgs/MoveArmFeedback
# The internal state that the move arm action currently is in
string state

# Time to completion - this is a combination of requested planning time and trajectory completion time
duration time_to_completion

"""
  __slots__ = ['action_goal','action_result','action_feedback']
  _slot_types = ['move_arm_msgs/MoveArmActionGoal','move_arm_msgs/MoveArmActionResult','move_arm_msgs/MoveArmActionFeedback']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       action_goal,action_result,action_feedback
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(MoveArmAction, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.action_goal is None:
        self.action_goal = move_arm_msgs.msg.MoveArmActionGoal()
      if self.action_result is None:
        self.action_result = move_arm_msgs.msg.MoveArmActionResult()
      if self.action_feedback is None:
        self.action_feedback = move_arm_msgs.msg.MoveArmActionFeedback()
    else:
      self.action_goal = move_arm_msgs.msg.MoveArmActionGoal()
      self.action_result = move_arm_msgs.msg.MoveArmActionResult()
      self.action_feedback = move_arm_msgs.msg.MoveArmActionFeedback()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs))
      _x = self.action_goal.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs))
      _x = self.action_goal.goal_id.id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.planner_service_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_b.pack(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.type))
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions))
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles))
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.seq, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.secs, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.nsecs))
      _x = self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.x, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.y, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.z, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.x, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.y, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.z, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.w, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.seq, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.secs, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.nsecs))
      _x = self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.start_state.joint_state.name:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.motion_plan_request.start_state.joint_state.position))
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity))
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.motion_plan_request.start_state.joint_state.effort))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.secs, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.nsecs))
      _x = self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.x, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.y, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.z, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.x, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.y, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.z, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.w))
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints:
        _x = val1.joint_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_4d.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints:
        _v1 = val1.header
        buff.write(_struct_I.pack(_v1.seq))
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v1.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.link_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v3 = val1.target_point_offset
        _x = _v3
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v4 = val1.position
        _x = _v4
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v5 = val1.constraint_region_shape
        buff.write(_struct_b.pack(_v5.type))
        length = len(_v5.dimensions)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v5.dimensions))
        length = len(_v5.triangles)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *_v5.triangles))
        length = len(_v5.vertices)
        buff.write(_struct_I.pack(length))
        for val3 in _v5.vertices:
          _x = val3
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v6 = val1.constraint_region_orientation
        _x = _v6
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_d.pack(val1.weight))
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints:
        _v7 = val1.header
        buff.write(_struct_I.pack(_v7.seq))
        _v8 = _v7.stamp
        _x = _v8
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v7.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.link_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.type))
        _v9 = val1.orientation
        _x = _v9
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_4d.pack(_x.absolute_roll_tolerance, _x.absolute_pitch_tolerance, _x.absolute_yaw_tolerance, _x.weight))
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.visibility_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.visibility_constraints:
        _v10 = val1.header
        buff.write(_struct_I.pack(_v10.seq))
        _v11 = _v10.stamp
        _x = _v11
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v10.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v12 = val1.target
        _v13 = _v12.header
        buff.write(_struct_I.pack(_v13.seq))
        _v14 = _v13.stamp
        _x = _v14
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v13.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v15 = _v12.point
        _x = _v15
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v16 = val1.sensor_pose
        _v17 = _v16.header
        buff.write(_struct_I.pack(_v17.seq))
        _v18 = _v17.stamp
        _x = _v18
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v17.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v19 = _v16.pose
        _v20 = _v19.position
        _x = _v20
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v21 = _v19.orientation
        _x = _v21
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_d.pack(val1.absolute_tolerance))
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints:
        _x = val1.joint_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_4d.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.position_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.position_constraints:
        _v22 = val1.header
        buff.write(_struct_I.pack(_v22.seq))
        _v23 = _v22.stamp
        _x = _v23
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v22.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.link_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v24 = val1.target_point_offset
        _x = _v24
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v25 = val1.position
        _x = _v25
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v26 = val1.constraint_region_shape
        buff.write(_struct_b.pack(_v26.type))
        length = len(_v26.dimensions)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v26.dimensions))
        length = len(_v26.triangles)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *_v26.triangles))
        length = len(_v26.vertices)
        buff.write(_struct_I.pack(length))
        for val3 in _v26.vertices:
          _x = val3
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v27 = val1.constraint_region_orientation
        _x = _v27
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_d.pack(val1.weight))
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints:
        _v28 = val1.header
        buff.write(_struct_I.pack(_v28.seq))
        _v29 = _v28.stamp
        _x = _v29
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v28.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.link_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.type))
        _v30 = val1.orientation
        _x = _v30
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_4d.pack(_x.absolute_roll_tolerance, _x.absolute_pitch_tolerance, _x.absolute_yaw_tolerance, _x.weight))
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.visibility_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.visibility_constraints:
        _v31 = val1.header
        buff.write(_struct_I.pack(_v31.seq))
        _v32 = _v31.stamp
        _x = _v32
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v31.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v33 = val1.target
        _v34 = _v33.header
        buff.write(_struct_I.pack(_v34.seq))
        _v35 = _v34.stamp
        _x = _v35
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v34.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v36 = _v33.point
        _x = _v36
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v37 = val1.sensor_pose
        _v38 = _v37.header
        buff.write(_struct_I.pack(_v38.seq))
        _v39 = _v38.stamp
        _x = _v39
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v38.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v40 = _v37.pose
        _v41 = _v40.position
        _x = _v41
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v42 = _v40.orientation
        _x = _v42
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_d.pack(val1.absolute_tolerance))
      length = len(self.action_goal.goal.motion_plan_request.allowed_contacts)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.allowed_contacts:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v43 = val1.shape
        buff.write(_struct_b.pack(_v43.type))
        length = len(_v43.dimensions)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v43.dimensions))
        length = len(_v43.triangles)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *_v43.triangles))
        length = len(_v43.vertices)
        buff.write(_struct_I.pack(length))
        for val3 in _v43.vertices:
          _x = val3
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v44 = val1.pose_stamped
        _v45 = _v44.header
        buff.write(_struct_I.pack(_v45.seq))
        _v46 = _v45.stamp
        _x = _v46
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v45.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v47 = _v44.pose
        _v48 = _v47.position
        _x = _v48
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v49 = _v47.orientation
        _x = _v49
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.link_names)
        buff.write(_struct_I.pack(length))
        for val2 in val1.link_names:
          length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
        buff.write(_struct_d.pack(val1.penetration_depth))
      length = len(self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations:
        _x = val1.object1
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.object2
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_di.pack(_x.penetration_distance, _x.operation))
      length = len(self.action_goal.goal.motion_plan_request.link_padding)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.link_padding:
        _x = val1.link_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_d.pack(val1.padding))
      _x = self.action_goal.goal.motion_plan_request.planner_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.motion_plan_request.group_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7i4B3I.pack(_x.action_goal.goal.motion_plan_request.num_planning_attempts, _x.action_goal.goal.motion_plan_request.allowed_planning_time.secs, _x.action_goal.goal.motion_plan_request.allowed_planning_time.nsecs, _x.action_goal.goal.motion_plan_request.expected_path_duration.secs, _x.action_goal.goal.motion_plan_request.expected_path_duration.nsecs, _x.action_goal.goal.motion_plan_request.expected_path_dt.secs, _x.action_goal.goal.motion_plan_request.expected_path_dt.nsecs, _x.action_goal.goal.accept_partial_plans, _x.action_goal.goal.accept_invalid_goals, _x.action_goal.goal.disable_ik, _x.action_goal.goal.disable_collision_monitoring, _x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs))
      _x = self.action_result.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs))
      _x = self.action_result.status.goal_id.id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.action_result.status.status))
      _x = self.action_result.status.text
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_i.pack(self.action_result.result.error_code.val))
      length = len(self.action_result.result.contacts)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_result.result.contacts:
        _v50 = val1.header
        buff.write(_struct_I.pack(_v50.seq))
        _v51 = _v50.stamp
        _x = _v51
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v50.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v52 = val1.position
        _x = _v52
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v53 = val1.normal
        _x = _v53
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        buff.write(_struct_d.pack(val1.depth))
        _x = val1.contact_body_1
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.attached_body_1
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_I.pack(val1.body_type_1))
        _x = val1.contact_body_2
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.attached_body_2
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_I.pack(val1.body_type_2))
      _x = self
      buff.write(_struct_3I.pack(_x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs))
      _x = self.action_feedback.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs))
      _x = self.action_feedback.status.goal_id.id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.action_feedback.status.status))
      _x = self.action_feedback.status.text
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_feedback.feedback.state
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2i.pack(_x.action_feedback.feedback.time_to_completion.secs, _x.action_feedback.feedback.time_to_completion.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.action_goal is None:
        self.action_goal = move_arm_msgs.msg.MoveArmActionGoal()
      if self.action_result is None:
        self.action_result = move_arm_msgs.msg.MoveArmActionResult()
      if self.action_feedback is None:
        self.action_feedback = move_arm_msgs.msg.MoveArmActionFeedback()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal_id.id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.planner_service_name = str[start:end]
      start = end
      end += 1
      (self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.type,) = _struct_b.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices.append(val1)
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.seq, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.secs, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.x, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.y, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.z, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.x, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.y, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.z, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.w, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.seq, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.secs, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.start_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.action_goal.goal.motion_plan_request.start_state.joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.position = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.effort = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.secs, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.x, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.y, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.z, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.x, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.y, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.z, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.joint_name = str[start:end]
        _x = val1
        start = end
        end += 32
        (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = _struct_4d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        _v54 = val1.header
        start = end
        end += 4
        (_v54.seq,) = _struct_I.unpack(str[start:end])
        _v55 = _v54.stamp
        _x = _v55
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v54.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.link_name = str[start:end]
        _v56 = val1.target_point_offset
        _x = _v56
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v57 = val1.position
        _x = _v57
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v58 = val1.constraint_region_shape
        start = end
        end += 1
        (_v58.type,) = _struct_b.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v58.dimensions = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        _v58.triangles = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v58.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          _x = val3
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v58.vertices.append(val3)
        _v59 = val1.constraint_region_orientation
        _x = _v59
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 8
        (val1.weight,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        _v60 = val1.header
        start = end
        end += 4
        (_v60.seq,) = _struct_I.unpack(str[start:end])
        _v61 = _v60.stamp
        _x = _v61
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v60.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.link_name = str[start:end]
        start = end
        end += 4
        (val1.type,) = _struct_i.unpack(str[start:end])
        _v62 = val1.orientation
        _x = _v62
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 32
        (_x.absolute_roll_tolerance, _x.absolute_pitch_tolerance, _x.absolute_yaw_tolerance, _x.weight,) = _struct_4d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.visibility_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.VisibilityConstraint()
        _v63 = val1.header
        start = end
        end += 4
        (_v63.seq,) = _struct_I.unpack(str[start:end])
        _v64 = _v63.stamp
        _x = _v64
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v63.frame_id = str[start:end]
        _v65 = val1.target
        _v66 = _v65.header
        start = end
        end += 4
        (_v66.seq,) = _struct_I.unpack(str[start:end])
        _v67 = _v66.stamp
        _x = _v67
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v66.frame_id = str[start:end]
        _v68 = _v65.point
        _x = _v68
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v69 = val1.sensor_pose
        _v70 = _v69.header
        start = end
        end += 4
        (_v70.seq,) = _struct_I.unpack(str[start:end])
        _v71 = _v70.stamp
        _x = _v71
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v70.frame_id = str[start:end]
        _v72 = _v69.pose
        _v73 = _v72.position
        _x = _v73
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v74 = _v72.orientation
        _x = _v74
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 8
        (val1.absolute_tolerance,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.visibility_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.joint_name = str[start:end]
        _x = val1
        start = end
        end += 32
        (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = _struct_4d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        _v75 = val1.header
        start = end
        end += 4
        (_v75.seq,) = _struct_I.unpack(str[start:end])
        _v76 = _v75.stamp
        _x = _v76
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v75.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.link_name = str[start:end]
        _v77 = val1.target_point_offset
        _x = _v77
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v78 = val1.position
        _x = _v78
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v79 = val1.constraint_region_shape
        start = end
        end += 1
        (_v79.type,) = _struct_b.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v79.dimensions = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        _v79.triangles = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v79.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          _x = val3
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v79.vertices.append(val3)
        _v80 = val1.constraint_region_orientation
        _x = _v80
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 8
        (val1.weight,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.position_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        _v81 = val1.header
        start = end
        end += 4
        (_v81.seq,) = _struct_I.unpack(str[start:end])
        _v82 = _v81.stamp
        _x = _v82
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v81.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.link_name = str[start:end]
        start = end
        end += 4
        (val1.type,) = _struct_i.unpack(str[start:end])
        _v83 = val1.orientation
        _x = _v83
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 32
        (_x.absolute_roll_tolerance, _x.absolute_pitch_tolerance, _x.absolute_yaw_tolerance, _x.weight,) = _struct_4d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.visibility_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.VisibilityConstraint()
        _v84 = val1.header
        start = end
        end += 4
        (_v84.seq,) = _struct_I.unpack(str[start:end])
        _v85 = _v84.stamp
        _x = _v85
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v84.frame_id = str[start:end]
        _v86 = val1.target
        _v87 = _v86.header
        start = end
        end += 4
        (_v87.seq,) = _struct_I.unpack(str[start:end])
        _v88 = _v87.stamp
        _x = _v88
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v87.frame_id = str[start:end]
        _v89 = _v86.point
        _x = _v89
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v90 = val1.sensor_pose
        _v91 = _v90.header
        start = end
        end += 4
        (_v91.seq,) = _struct_I.unpack(str[start:end])
        _v92 = _v91.stamp
        _x = _v92
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v91.frame_id = str[start:end]
        _v93 = _v90.pose
        _v94 = _v93.position
        _x = _v94
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v95 = _v93.orientation
        _x = _v95
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 8
        (val1.absolute_tolerance,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.visibility_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.allowed_contacts = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.AllowedContactSpecification()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        _v96 = val1.shape
        start = end
        end += 1
        (_v96.type,) = _struct_b.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v96.dimensions = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        _v96.triangles = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v96.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          _x = val3
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v96.vertices.append(val3)
        _v97 = val1.pose_stamped
        _v98 = _v97.header
        start = end
        end += 4
        (_v98.seq,) = _struct_I.unpack(str[start:end])
        _v99 = _v98.stamp
        _x = _v99
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v98.frame_id = str[start:end]
        _v100 = _v97.pose
        _v101 = _v100.position
        _x = _v101
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v102 = _v100.orientation
        _x = _v102
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.link_names = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2 = str[start:end]
          val1.link_names.append(val2)
        start = end
        end += 8
        (val1.penetration_depth,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.allowed_contacts.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.CollisionOperation()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.object1 = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.object2 = str[start:end]
        _x = val1
        start = end
        end += 12
        (_x.penetration_distance, _x.operation,) = _struct_di.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.link_padding = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.LinkPadding()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.link_name = str[start:end]
        start = end
        end += 8
        (val1.padding,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.link_padding.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.planner_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.group_name = str[start:end]
      _x = self
      start = end
      end += 44
      (_x.action_goal.goal.motion_plan_request.num_planning_attempts, _x.action_goal.goal.motion_plan_request.allowed_planning_time.secs, _x.action_goal.goal.motion_plan_request.allowed_planning_time.nsecs, _x.action_goal.goal.motion_plan_request.expected_path_duration.secs, _x.action_goal.goal.motion_plan_request.expected_path_duration.nsecs, _x.action_goal.goal.motion_plan_request.expected_path_dt.secs, _x.action_goal.goal.motion_plan_request.expected_path_dt.nsecs, _x.action_goal.goal.accept_partial_plans, _x.action_goal.goal.accept_invalid_goals, _x.action_goal.goal.disable_ik, _x.action_goal.goal.disable_collision_monitoring, _x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs,) = _struct_7i4B3I.unpack(str[start:end])
      self.action_goal.goal.accept_partial_plans = bool(self.action_goal.goal.accept_partial_plans)
      self.action_goal.goal.accept_invalid_goals = bool(self.action_goal.goal.accept_invalid_goals)
      self.action_goal.goal.disable_ik = bool(self.action_goal.goal.disable_ik)
      self.action_goal.goal.disable_collision_monitoring = bool(self.action_goal.goal.disable_collision_monitoring)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_result.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_result.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_result.status.status,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_result.status.text = str[start:end]
      start = end
      end += 4
      (self.action_result.result.error_code.val,) = _struct_i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_result.result.contacts = []
      for i in xrange(0, length):
        val1 = planning_environment_msgs.msg.ContactInformation()
        _v103 = val1.header
        start = end
        end += 4
        (_v103.seq,) = _struct_I.unpack(str[start:end])
        _v104 = _v103.stamp
        _x = _v104
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v103.frame_id = str[start:end]
        _v105 = val1.position
        _x = _v105
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v106 = val1.normal
        _x = _v106
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 8
        (val1.depth,) = _struct_d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.contact_body_1 = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.attached_body_1 = str[start:end]
        start = end
        end += 4
        (val1.body_type_1,) = _struct_I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.contact_body_2 = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.attached_body_2 = str[start:end]
        start = end
        end += 4
        (val1.body_type_2,) = _struct_I.unpack(str[start:end])
        self.action_result.result.contacts.append(val1)
      _x = self
      start = end
      end += 12
      (_x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_feedback.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_feedback.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_feedback.status.status,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_feedback.status.text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_feedback.feedback.state = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_feedback.feedback.time_to_completion.secs, _x.action_feedback.feedback.time_to_completion.nsecs,) = _struct_2i.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs))
      _x = self.action_goal.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs))
      _x = self.action_goal.goal_id.id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.planner_service_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_b.pack(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.type))
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions.tostring())
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles.tostring())
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.seq, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.secs, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.nsecs))
      _x = self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.x, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.y, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.z, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.x, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.y, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.z, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.w, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.seq, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.secs, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.nsecs))
      _x = self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.start_state.joint_state.name:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.action_goal.goal.motion_plan_request.start_state.joint_state.position.tostring())
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity.tostring())
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.action_goal.goal.motion_plan_request.start_state.joint_state.effort.tostring())
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.secs, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.nsecs))
      _x = self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.x, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.y, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.z, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.x, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.y, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.z, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.w))
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints:
        _x = val1.joint_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_4d.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints:
        _v107 = val1.header
        buff.write(_struct_I.pack(_v107.seq))
        _v108 = _v107.stamp
        _x = _v108
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v107.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.link_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v109 = val1.target_point_offset
        _x = _v109
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v110 = val1.position
        _x = _v110
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v111 = val1.constraint_region_shape
        buff.write(_struct_b.pack(_v111.type))
        length = len(_v111.dimensions)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v111.dimensions.tostring())
        length = len(_v111.triangles)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(_v111.triangles.tostring())
        length = len(_v111.vertices)
        buff.write(_struct_I.pack(length))
        for val3 in _v111.vertices:
          _x = val3
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v112 = val1.constraint_region_orientation
        _x = _v112
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_d.pack(val1.weight))
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints:
        _v113 = val1.header
        buff.write(_struct_I.pack(_v113.seq))
        _v114 = _v113.stamp
        _x = _v114
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v113.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.link_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.type))
        _v115 = val1.orientation
        _x = _v115
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_4d.pack(_x.absolute_roll_tolerance, _x.absolute_pitch_tolerance, _x.absolute_yaw_tolerance, _x.weight))
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.visibility_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.visibility_constraints:
        _v116 = val1.header
        buff.write(_struct_I.pack(_v116.seq))
        _v117 = _v116.stamp
        _x = _v117
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v116.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v118 = val1.target
        _v119 = _v118.header
        buff.write(_struct_I.pack(_v119.seq))
        _v120 = _v119.stamp
        _x = _v120
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v119.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v121 = _v118.point
        _x = _v121
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v122 = val1.sensor_pose
        _v123 = _v122.header
        buff.write(_struct_I.pack(_v123.seq))
        _v124 = _v123.stamp
        _x = _v124
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v123.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v125 = _v122.pose
        _v126 = _v125.position
        _x = _v126
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v127 = _v125.orientation
        _x = _v127
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_d.pack(val1.absolute_tolerance))
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints:
        _x = val1.joint_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_4d.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.position_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.position_constraints:
        _v128 = val1.header
        buff.write(_struct_I.pack(_v128.seq))
        _v129 = _v128.stamp
        _x = _v129
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v128.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.link_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v130 = val1.target_point_offset
        _x = _v130
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v131 = val1.position
        _x = _v131
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v132 = val1.constraint_region_shape
        buff.write(_struct_b.pack(_v132.type))
        length = len(_v132.dimensions)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v132.dimensions.tostring())
        length = len(_v132.triangles)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(_v132.triangles.tostring())
        length = len(_v132.vertices)
        buff.write(_struct_I.pack(length))
        for val3 in _v132.vertices:
          _x = val3
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v133 = val1.constraint_region_orientation
        _x = _v133
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_d.pack(val1.weight))
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints:
        _v134 = val1.header
        buff.write(_struct_I.pack(_v134.seq))
        _v135 = _v134.stamp
        _x = _v135
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v134.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.link_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.type))
        _v136 = val1.orientation
        _x = _v136
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_4d.pack(_x.absolute_roll_tolerance, _x.absolute_pitch_tolerance, _x.absolute_yaw_tolerance, _x.weight))
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.visibility_constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.visibility_constraints:
        _v137 = val1.header
        buff.write(_struct_I.pack(_v137.seq))
        _v138 = _v137.stamp
        _x = _v138
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v137.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v139 = val1.target
        _v140 = _v139.header
        buff.write(_struct_I.pack(_v140.seq))
        _v141 = _v140.stamp
        _x = _v141
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v140.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v142 = _v139.point
        _x = _v142
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v143 = val1.sensor_pose
        _v144 = _v143.header
        buff.write(_struct_I.pack(_v144.seq))
        _v145 = _v144.stamp
        _x = _v145
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v144.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v146 = _v143.pose
        _v147 = _v146.position
        _x = _v147
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v148 = _v146.orientation
        _x = _v148
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_d.pack(val1.absolute_tolerance))
      length = len(self.action_goal.goal.motion_plan_request.allowed_contacts)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.allowed_contacts:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v149 = val1.shape
        buff.write(_struct_b.pack(_v149.type))
        length = len(_v149.dimensions)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v149.dimensions.tostring())
        length = len(_v149.triangles)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(_v149.triangles.tostring())
        length = len(_v149.vertices)
        buff.write(_struct_I.pack(length))
        for val3 in _v149.vertices:
          _x = val3
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v150 = val1.pose_stamped
        _v151 = _v150.header
        buff.write(_struct_I.pack(_v151.seq))
        _v152 = _v151.stamp
        _x = _v152
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v151.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v153 = _v150.pose
        _v154 = _v153.position
        _x = _v154
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v155 = _v153.orientation
        _x = _v155
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.link_names)
        buff.write(_struct_I.pack(length))
        for val2 in val1.link_names:
          length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
        buff.write(_struct_d.pack(val1.penetration_depth))
      length = len(self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations:
        _x = val1.object1
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.object2
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_di.pack(_x.penetration_distance, _x.operation))
      length = len(self.action_goal.goal.motion_plan_request.link_padding)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.motion_plan_request.link_padding:
        _x = val1.link_name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_d.pack(val1.padding))
      _x = self.action_goal.goal.motion_plan_request.planner_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.motion_plan_request.group_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7i4B3I.pack(_x.action_goal.goal.motion_plan_request.num_planning_attempts, _x.action_goal.goal.motion_plan_request.allowed_planning_time.secs, _x.action_goal.goal.motion_plan_request.allowed_planning_time.nsecs, _x.action_goal.goal.motion_plan_request.expected_path_duration.secs, _x.action_goal.goal.motion_plan_request.expected_path_duration.nsecs, _x.action_goal.goal.motion_plan_request.expected_path_dt.secs, _x.action_goal.goal.motion_plan_request.expected_path_dt.nsecs, _x.action_goal.goal.accept_partial_plans, _x.action_goal.goal.accept_invalid_goals, _x.action_goal.goal.disable_ik, _x.action_goal.goal.disable_collision_monitoring, _x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs))
      _x = self.action_result.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs))
      _x = self.action_result.status.goal_id.id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.action_result.status.status))
      _x = self.action_result.status.text
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_i.pack(self.action_result.result.error_code.val))
      length = len(self.action_result.result.contacts)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_result.result.contacts:
        _v156 = val1.header
        buff.write(_struct_I.pack(_v156.seq))
        _v157 = _v156.stamp
        _x = _v157
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v156.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v158 = val1.position
        _x = _v158
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v159 = val1.normal
        _x = _v159
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        buff.write(_struct_d.pack(val1.depth))
        _x = val1.contact_body_1
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.attached_body_1
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_I.pack(val1.body_type_1))
        _x = val1.contact_body_2
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.attached_body_2
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_I.pack(val1.body_type_2))
      _x = self
      buff.write(_struct_3I.pack(_x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs))
      _x = self.action_feedback.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs))
      _x = self.action_feedback.status.goal_id.id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.action_feedback.status.status))
      _x = self.action_feedback.status.text
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_feedback.feedback.state
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2i.pack(_x.action_feedback.feedback.time_to_completion.secs, _x.action_feedback.feedback.time_to_completion.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.action_goal is None:
        self.action_goal = move_arm_msgs.msg.MoveArmActionGoal()
      if self.action_result is None:
        self.action_result = move_arm_msgs.msg.MoveArmActionResult()
      if self.action_feedback is None:
        self.action_feedback = move_arm_msgs.msg.MoveArmActionFeedback()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal_id.id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.planner_service_name = str[start:end]
      start = end
      end += 1
      (self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.type,) = _struct_b.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices.append(val1)
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.seq, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.secs, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.x, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.y, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.z, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.x, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.y, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.z, _x.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.w, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.seq, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.secs, _x.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.start_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.action_goal.goal.motion_plan_request.start_state.joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.secs, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.x, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.y, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.z, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.x, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.y, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.z, _x.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.joint_name = str[start:end]
        _x = val1
        start = end
        end += 32
        (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = _struct_4d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        _v160 = val1.header
        start = end
        end += 4
        (_v160.seq,) = _struct_I.unpack(str[start:end])
        _v161 = _v160.stamp
        _x = _v161
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v160.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.link_name = str[start:end]
        _v162 = val1.target_point_offset
        _x = _v162
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v163 = val1.position
        _x = _v163
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v164 = val1.constraint_region_shape
        start = end
        end += 1
        (_v164.type,) = _struct_b.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v164.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        _v164.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v164.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          _x = val3
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v164.vertices.append(val3)
        _v165 = val1.constraint_region_orientation
        _x = _v165
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 8
        (val1.weight,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        _v166 = val1.header
        start = end
        end += 4
        (_v166.seq,) = _struct_I.unpack(str[start:end])
        _v167 = _v166.stamp
        _x = _v167
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v166.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.link_name = str[start:end]
        start = end
        end += 4
        (val1.type,) = _struct_i.unpack(str[start:end])
        _v168 = val1.orientation
        _x = _v168
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 32
        (_x.absolute_roll_tolerance, _x.absolute_pitch_tolerance, _x.absolute_yaw_tolerance, _x.weight,) = _struct_4d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.visibility_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.VisibilityConstraint()
        _v169 = val1.header
        start = end
        end += 4
        (_v169.seq,) = _struct_I.unpack(str[start:end])
        _v170 = _v169.stamp
        _x = _v170
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v169.frame_id = str[start:end]
        _v171 = val1.target
        _v172 = _v171.header
        start = end
        end += 4
        (_v172.seq,) = _struct_I.unpack(str[start:end])
        _v173 = _v172.stamp
        _x = _v173
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v172.frame_id = str[start:end]
        _v174 = _v171.point
        _x = _v174
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v175 = val1.sensor_pose
        _v176 = _v175.header
        start = end
        end += 4
        (_v176.seq,) = _struct_I.unpack(str[start:end])
        _v177 = _v176.stamp
        _x = _v177
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v176.frame_id = str[start:end]
        _v178 = _v175.pose
        _v179 = _v178.position
        _x = _v179
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v180 = _v178.orientation
        _x = _v180
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 8
        (val1.absolute_tolerance,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.visibility_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.joint_name = str[start:end]
        _x = val1
        start = end
        end += 32
        (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = _struct_4d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        _v181 = val1.header
        start = end
        end += 4
        (_v181.seq,) = _struct_I.unpack(str[start:end])
        _v182 = _v181.stamp
        _x = _v182
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v181.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.link_name = str[start:end]
        _v183 = val1.target_point_offset
        _x = _v183
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v184 = val1.position
        _x = _v184
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v185 = val1.constraint_region_shape
        start = end
        end += 1
        (_v185.type,) = _struct_b.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v185.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        _v185.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v185.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          _x = val3
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v185.vertices.append(val3)
        _v186 = val1.constraint_region_orientation
        _x = _v186
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 8
        (val1.weight,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.position_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        _v187 = val1.header
        start = end
        end += 4
        (_v187.seq,) = _struct_I.unpack(str[start:end])
        _v188 = _v187.stamp
        _x = _v188
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v187.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.link_name = str[start:end]
        start = end
        end += 4
        (val1.type,) = _struct_i.unpack(str[start:end])
        _v189 = val1.orientation
        _x = _v189
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 32
        (_x.absolute_roll_tolerance, _x.absolute_pitch_tolerance, _x.absolute_yaw_tolerance, _x.weight,) = _struct_4d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.visibility_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.VisibilityConstraint()
        _v190 = val1.header
        start = end
        end += 4
        (_v190.seq,) = _struct_I.unpack(str[start:end])
        _v191 = _v190.stamp
        _x = _v191
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v190.frame_id = str[start:end]
        _v192 = val1.target
        _v193 = _v192.header
        start = end
        end += 4
        (_v193.seq,) = _struct_I.unpack(str[start:end])
        _v194 = _v193.stamp
        _x = _v194
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v193.frame_id = str[start:end]
        _v195 = _v192.point
        _x = _v195
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v196 = val1.sensor_pose
        _v197 = _v196.header
        start = end
        end += 4
        (_v197.seq,) = _struct_I.unpack(str[start:end])
        _v198 = _v197.stamp
        _x = _v198
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v197.frame_id = str[start:end]
        _v199 = _v196.pose
        _v200 = _v199.position
        _x = _v200
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v201 = _v199.orientation
        _x = _v201
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 8
        (val1.absolute_tolerance,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.visibility_constraints.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.allowed_contacts = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.AllowedContactSpecification()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        _v202 = val1.shape
        start = end
        end += 1
        (_v202.type,) = _struct_b.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v202.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        _v202.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v202.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          _x = val3
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v202.vertices.append(val3)
        _v203 = val1.pose_stamped
        _v204 = _v203.header
        start = end
        end += 4
        (_v204.seq,) = _struct_I.unpack(str[start:end])
        _v205 = _v204.stamp
        _x = _v205
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v204.frame_id = str[start:end]
        _v206 = _v203.pose
        _v207 = _v206.position
        _x = _v207
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v208 = _v206.orientation
        _x = _v208
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.link_names = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2 = str[start:end]
          val1.link_names.append(val2)
        start = end
        end += 8
        (val1.penetration_depth,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.allowed_contacts.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.CollisionOperation()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.object1 = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.object2 = str[start:end]
        _x = val1
        start = end
        end += 12
        (_x.penetration_distance, _x.operation,) = _struct_di.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.motion_plan_request.link_padding = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.LinkPadding()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.link_name = str[start:end]
        start = end
        end += 8
        (val1.padding,) = _struct_d.unpack(str[start:end])
        self.action_goal.goal.motion_plan_request.link_padding.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.planner_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_goal.goal.motion_plan_request.group_name = str[start:end]
      _x = self
      start = end
      end += 44
      (_x.action_goal.goal.motion_plan_request.num_planning_attempts, _x.action_goal.goal.motion_plan_request.allowed_planning_time.secs, _x.action_goal.goal.motion_plan_request.allowed_planning_time.nsecs, _x.action_goal.goal.motion_plan_request.expected_path_duration.secs, _x.action_goal.goal.motion_plan_request.expected_path_duration.nsecs, _x.action_goal.goal.motion_plan_request.expected_path_dt.secs, _x.action_goal.goal.motion_plan_request.expected_path_dt.nsecs, _x.action_goal.goal.accept_partial_plans, _x.action_goal.goal.accept_invalid_goals, _x.action_goal.goal.disable_ik, _x.action_goal.goal.disable_collision_monitoring, _x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs,) = _struct_7i4B3I.unpack(str[start:end])
      self.action_goal.goal.accept_partial_plans = bool(self.action_goal.goal.accept_partial_plans)
      self.action_goal.goal.accept_invalid_goals = bool(self.action_goal.goal.accept_invalid_goals)
      self.action_goal.goal.disable_ik = bool(self.action_goal.goal.disable_ik)
      self.action_goal.goal.disable_collision_monitoring = bool(self.action_goal.goal.disable_collision_monitoring)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_result.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_result.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_result.status.status,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_result.status.text = str[start:end]
      start = end
      end += 4
      (self.action_result.result.error_code.val,) = _struct_i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_result.result.contacts = []
      for i in xrange(0, length):
        val1 = planning_environment_msgs.msg.ContactInformation()
        _v209 = val1.header
        start = end
        end += 4
        (_v209.seq,) = _struct_I.unpack(str[start:end])
        _v210 = _v209.stamp
        _x = _v210
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v209.frame_id = str[start:end]
        _v211 = val1.position
        _x = _v211
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v212 = val1.normal
        _x = _v212
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 8
        (val1.depth,) = _struct_d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.contact_body_1 = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.attached_body_1 = str[start:end]
        start = end
        end += 4
        (val1.body_type_1,) = _struct_I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.contact_body_2 = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.attached_body_2 = str[start:end]
        start = end
        end += 4
        (val1.body_type_2,) = _struct_I.unpack(str[start:end])
        self.action_result.result.contacts.append(val1)
      _x = self
      start = end
      end += 12
      (_x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_feedback.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_feedback.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_feedback.status.status,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_feedback.status.text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_feedback.feedback.state = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_feedback.feedback.time_to_completion.secs, _x.action_feedback.feedback.time_to_completion.nsecs,) = _struct_2i.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_7i4B3I = struct.Struct("<7i4B3I")
_struct_b = struct.Struct("<b")
_struct_d = struct.Struct("<d")
_struct_di = struct.Struct("<di")
_struct_B = struct.Struct("<B")
_struct_2I = struct.Struct("<2I")
_struct_2i = struct.Struct("<2i")
_struct_i = struct.Struct("<i")
_struct_3I = struct.Struct("<3I")
_struct_7d = struct.Struct("<7d")
_struct_4d = struct.Struct("<4d")
_struct_7d3I = struct.Struct("<7d3I")
_struct_3d = struct.Struct("<3d")
